博客
关于我
强烈建议你试试无所不能的chatGPT,快点击我
Revit API射线法读取空间中相交的元素
阅读量:7068 次
发布时间:2019-06-28

本文共 2078 字,大约阅读时间需要 6 分钟。

Revit API提供根据射线来寻找经过的元素。方法是固定模式,没什么好说。
关键代码:
doc.FindReferencesWithContextByDirection(ptStart, (ptEnd - ptStart), view3d)
//
射线法寻找穿过的对象
[TransactionAttribute(Autodesk.Revit.Attributes.TransactionMode.Manual)]
public 
class FindSupporting : IExternalCommand
{
    
public Result Execute(ExternalCommandData commandData, 
ref 
string messages, ElementSet elements)
    {
        UIApplication app = commandData.Application;
        Document doc = app.ActiveUIDocument.Document;
        Transaction trans = 
new Transaction(doc, 
"
ExComm
");
        trans.Start();
        Selection sel = app.ActiveUIDocument.Selection;
        
//
Reference ref1 = sel.PickObject(ObjectType.Element, "Please pick a beam");
        
//
FamilyInstance beam = doc.GetElement(ref1) as FamilyInstance;
        Reference ref1 = sel.PickObject(ObjectType.Element, 
"
Please pick a duct
");
        Duct duct = doc.GetElement(ref1) 
as Duct;
        
//
Read the beam's location line
        
//
LocationCurve lc = beam.Location as LocationCurve;
        LocationCurve lc = duct.Location 
as LocationCurve;
        Curve curve = lc.Curve;
        
//
取得线端点的方法
        XYZ ptStart = curve.get_EndPoint(
0);
        XYZ ptEnd = curve.get_EndPoint(
1);
        
//
move the two point a little bit lower, so the ray can go through the wall
        XYZ offset = 
new XYZ(
0
0
0.01);
//
向量偏移的方法,这里向下偏移。
        ptStart = ptStart - offset;
        ptEnd = ptEnd - offset;
        View3D view3d = 
null;
        view3d = doc.ActiveView 
as View3D;
        
if (view3d == 
null)
        {
            TaskDialog.Show(
"
3D view
"
"
current view should be 3D view
");
            
return Result.Failed;
        }
        
double beamLen = curve.Length;
        
//
终点-起点就是线的方向。这里是射线法的关键代码。必须在三维视图下。
        IList<ReferenceWithContext> references = doc.FindReferencesWithContextByDirection(ptStart, (ptEnd - ptStart), view3d);
        
//
ElementSet wallSet = app.Application.Create.NewElementSet();
        sel.Elements.Clear();
        
double tolerate = 
0.00001;
        
foreach (ReferenceWithContext reference 
in references)
        {
            Reference ref2 = reference.GetReference();
//
取得引用
            ElementId id = ref2.ElementId;
            Element elem = doc.get_Element(id);
            
if (elem 
is Wall)
            {
                
if (reference.Proximity < (beamLen + tolerate))
//
Proximity接近,即与射线原点的距离。
                {
                    sel.Elements.Add(elem);
                }
            }
        }
        trans.Commit();
        
return Result.Succeeded;
    }
}
url:

转载地址:http://ueqll.baihongyu.com/

你可能感兴趣的文章
volley5--Request<T>类的介绍
查看>>
mongodb集合的增删
查看>>
LeetCode 161: One Edit Distance
查看>>
SPOJ220 Relevant Phrases of Annihilation
查看>>
python基础学习10----集合
查看>>
ETL工具—Kettle数据的导入导出—批量Excel表到数据库
查看>>
知识思考
查看>>
OpenCV安装
查看>>
在一行上打印(完成度打印)
查看>>
linux运维人员常用的150个命令
查看>>
boost库 线程使用
查看>>
bzoj3068: 小白树
查看>>
Dubbo学习总结(3)——Dubbo-Admin管理平台和Zookeeper注册中心的搭建
查看>>
【Python3爬虫】selenium入门
查看>>
C语言语法
查看>>
Ruby判断文件是否存在
查看>>
servlet中避免405错误的产生
查看>>
Git的checkout, reset, revert
查看>>
取余递归
查看>>
Java金钱小写转大写
查看>>